SystemOrganization addCategory: #'Pier-Admin'!

WAPresenter subclass: #PRContextViewer
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin'!

Object subclass: #FileLibraryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin'!

!FileLibraryTest classSide methodsFor: 'as yet unclassified' stamp: 'NickAger 7/3/2011 09:45'!
installFileLibrary
	| mylib |
	mylib := WAExternalFileLibrary new.
	mylib preferenceAt: #directory put: '/Volumes/index_bestanden'.
	mylib preferenceAt: #listing put: true.
	WADispatcher default register: mylib at: 'templatefiles'! !

!FileLibraryTest classSide methodsFor: 'as yet unclassified' stamp: 'NorbertHartl 7/3/2011 10:12'!
loadDependentPackages
	Gofer new 
		squeaksource: 'MetacelloRepository';
		package: 'ConfigurationOfSPort2';
		load.
	
	(Smalltalk at: #ConfigurationOfSPort2) project lastVersion load.

	Gofer new
		squeaksource: 'Seaside30LGPL';
		package: 'Seaside-FileSystem';
		load! !

!FileLibraryTest classSide methodsFor: 'as yet unclassified' stamp: 'NickAger 7/3/2011 10:05'!
repositories
	MCHttpRepository
	location: 'http://www.squeaksource.com/Seaside30LGPL'
	user: ''
	password: ''.
	
	MCHttpRepository
	location: 'http://www.squeaksource.com/SPort'
	user: ''
	password: ''.
	
	"using SPort - Sport-2.031"! !

Object subclass: #PRAdminDistribution
	instanceVariableNames: 'blog contentsWidget environmentPage metaEnvironmentPage breadcrumbWidget commandsPage googleAnalyticsWidget siteTitlePage sitemapPage stylesheetFile systemManagementPage viewsPage menuWidget loginCommandWidget mainEnvironmentPage childrenWidget postTickerWidget rootPage kernel syntaxPage aboutPage blogArchiveWidget blogEnvironmentPage poweredByPage searchWidget headerPage footerPage shortcutsPage loggedInUserPage designChooserWidget fileSettingsWidget documentWidget systemPage componentsPage templatesPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin'!

!PRAdminDistribution classSide methodsFor: 'accessing' stamp: 'NorbertHartl 7/2/2011 18:02'!
register
	^ self new register! !

!PRAdminDistribution classSide methodsFor: 'accessing' stamp: 'NorbertHartl 7/2/2011 18:02'!
title
	"override this method to name the design"
	^'Default'! !

!PRAdminDistribution classSide methodsFor: 'accessing' stamp: 'NorbertHartl 7/2/2011 18:02'!
workspaceText

	^
'"----------PIER-----------
Pier is already running at:
http://localhost:8080/pier

The Seaside server administration interface can be reached at: 
http://localhost:8080/config

The default username/password for Pier is admin/pier.
The default username/password for Seaside admin/seaside.

For more information about Pier check:
http://www.piercms.com
-------------------------"

"Web server management"
WAKomEncoded startOn: 8080.
WAKomEncoded stop.

"Memory cleanup"
WARegistry clearAllHandlers.
MCFileBasedRepository flushAllCaches.
Smalltalk garbageCollect.

"In memory persistency (default)"
PRKernel instances anyOne persistency: PRHistoryPersistency new.

"Image persistency (save up to 3 images and in 30 mins after a change)"
PRKernel instances anyOne persistency: (PRImagePersistency new 
											duration: 30 minutes;
											maxImages: 3).
			
"Reset all Pier settings to the original ones"
PRDistribution new register.

"Useful shortcuts"
PRKernel instances anyOne root.'! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
aboutPage
	^ aboutPage ifNil: [
		aboutPage := (PRPage named: 'about')
					title: 'About Pier';
					contents:
'*Pier>http://www.piercms.com* is a content management system that aims at allowing users to manage their content from the browser.

The central concept in Pier is the one of Structure. For example, the current page is a structure. The */blog* is also a structure, but it is slightly different than a page. A file is also a structure.

Commands can be executed on a Structure. For example, a Structure can be edited. In the current setup you can edit this site after logging in (the commands appear in the footer). Once in edit mode, you can use the *syntax*. To make life easier, Pier also offers access to these commands via *shortcuts>http://www.piercms.com/doc/shortcuts*.

Any Structure can be Viewed. The default View is the one that renders the structure for normal usage. Another example, is the Browse View which offers a file system like view on the Pier structures.

Any Structure has an environment which defines the template. For example, the environment of this page is */system/templates* (you have to be logged in to see it). To set the environment to be a different page use the Settings command. To edit the environment use the Edit Design command.

A Structure can contain Widgets. For example, the environment of this page contains a menu widget on top, and a widget that enumerates the children of the current sturcture to the right.

More about Pier can be found at: *http://www.piercms.com*.'
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
blog
	^ blog ifNil: [
		blog := (PBBlog named: 'blog')
		addChild: (
			(PBPost named: 'downtobusiness')
			title: 'Down to business';
			contents: 'I like blogging, so here is my second post.';
			publication: TimeStamp now;
			addChild: ((PBComment named: '1')
				contents: 'We are glad to see that you get serious about blogging. Btw, this is a comment.';
				author: 'The Pier Team';
				website: 'http://www.piercms.com';
				yourself
				);
			yourself
		);
		addChild: (
			(PBPost named: 'hello')
			title: 'Hello';
			contents: 'Hi!! This is my first post.';
			publication: TimeStamp today;
			yourself
		);
		yourself
	].
! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
blogArchiveWidget
	^ blogArchiveWidget ifNil: [
		blogArchiveWidget := (PRComponent named: 'blogarchive')
		title: 'Blog Archive';
		componentClass: PBPostArchive;
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
blogEnvironmentPage
	^ blogEnvironmentPage ifNil: [
		blogEnvironmentPage := (PRPage named: 'blogenvironment')
		title: '_Blog Environment';
		contents: 
'{{{<div class="container">
	}}}+/system/components/header+{{{
	<div class="column span-24 last mainbody">
		<h1 class="heading">}}}*>value:structure|level=2*{{{</h1>
		<h1>}}}*>value:structure|level=0|lower=3*{{{</h1>
		<div class="column span-12 contents">
			}}}+/system/components/contents+{{{
		</div>
		<div class="column span-6 prepend-6 last sidebar">
			<h2>Archive</h2>
			}}}+/system/components/blogarchive+{{{
		</div>
	</div>
	}}}+/system/components/footer+{{{
</div>}}}
+/system/components/googleanalytics+
';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
breadcrumbWidget
	^ breadcrumbWidget ifNil: [breadcrumbWidget := (PRComponent named: 'breadcrumb')
		componentClass: PRBreadcrumbWidget;
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
childrenWidget
	^ childrenWidget ifNil: [childrenWidget := (PRComponent named: 'children')
		componentClass: PRChildrenWidget;
		write: 2
			using: PRChildrenWidget descriptionLevel;
		write: true
			using: PRChildrenWidget descriptionExpand;
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
commandsPage
	^ commandsPage ifNil: [
		commandsPage := (PRPage named: 'commands') 
		addChild: ((PRComponent named: 'widget') componentClass: PRCommandsWidget; yourself);
		contents: 'Commands: +widget+';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
componentsPage
	^ componentsPage ifNil: [
		componentsPage := (PRPage named: 'components')
		contents: '*value:children|link*';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
contentsWidget
	^ contentsWidget ifNil: [
		contentsWidget := (PRComponent named: 'contents')
		componentClass: PRContentsWidget;
		write: '' using: PRContentsWidget descriptionHeading;
		yourself
	].! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
documentWidget
	^ documentWidget ifNil: [
		documentWidget := (PRComponent named: 'sidebar')
		title: 'Sidebar Document';
		componentClass: PRDocumentWidget;
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
environmentPage
	^ environmentPage ifNil: [
		environmentPage := (PRPage named: 'environment')
		title: '_Environment';
		contents: 
'{{{<div class="container">
	}}}+/system/components/header+{{{
	<div class="column span-24 last mainbody">
		<h1 class="heading">}}}*>value:structure|level=2*{{{</h1>
		<h1>}}}*>value:structure|level=0|lower=3*{{{</h1>
		<div class="column span-12 contents">
			}}}+/system/components/contents+{{{
		</div>
		<div class="column span-6 prepend-6 last sidebar">
			<h2>Navigation</h2>
			}}}+/system/components/children+{{{
		</div>
	</div>
	}}}+/system/components/footer+{{{
</div>}}}
+/system/components/googleanalytics+
';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
footerPage
	^ footerPage ifNil: [
		footerPage := (PRPage named: 'footer')
		contents:
'{{{<div class="footer column span-24 last">
	<div class="column span-18">
		}}}+/system/components/justlogincommand+
		+/system/components/loggedinuser+{{{
		<div class="commands">}}}+/system/components/commands+{{{</div>
		<div class="views">}}}+/system/components/views+{{{</div>
		<div class="sitemap">}}}+/system/components/sitemap+{{{</div>
	</div>
	<div class="column span-6 last">}}}+/system/components/poweredby+{{{</div>
</div>}}}';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
googleAnalyticsWidget
	^ googleAnalyticsWidget ifNil: [ 
		googleAnalyticsWidget := (PRComponent named: 'googleanalytics')
		title: 'Google Analytics';
		componentClass: PRGoogleAnalyticsWidget
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
headerPage
	^ headerPage ifNil: [
		headerPage := (PRPage named: 'header')
		contents:
'{{{<div class="column span-24 last header">
	<div class="menu">}}}+/system/components/menu|menu+{{{</div>
</div>}}}';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'creation' stamp: 'NorbertHartl 7/2/2011 18:02'!
kernel
	^ kernel ifNil: [
		kernel := PRKernel named: 'pier'.
		kernel root: self root.
		kernel
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
loggedInUserPage
	^ loggedInUserPage ifNil: [
		loggedInUserPage := (PRPage named: 'loggedinuser') 
		addChild: ((PRComponent named: 'widget') componentClass: PUSecurityWidget; yourself);
		contents: 'Logged in as *value:user* (+widget+?)';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
loginCommandWidget
	^ loginCommandWidget ifNil: [
		loginCommandWidget := (PRComponent named: 'justlogincommand')
		title: 'Just Login Command';
		componentClass: PRCommandsWidget;
		write: (Array with: PULogin) using: PRCommandsWidget descriptionCommandClasses ;
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
mainEnvironmentPage
	^ mainEnvironmentPage ifNil: [
		mainEnvironmentPage := (PRPage named: 'mainenvironment')
		title: '_Main Environment';
		contents: 
'{{{<div class="container">
	}}}+/system/components/header+{{{
	<div class="column span-24 last mainbody">
		<h1 class="heading">}}}*value:structure*{{{</h1>
		<div class="contents column span-12">}}}+/system/components/contents+{{{</div>
		<div class="postticker column prepend-6 span-6 last">
			<h2>What''s new</h2>
			}}}+/system/components/postticker+
			+/system/components/sidebar+{{{
		</div>
	</div>
	}}}+/system/components/footer+{{{
</div>}}}
+/system/components/googleanalytics+
';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'rights' stamp: 'NorbertHartl 7/2/2011 18:02'!
makePrivate: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRAdminDistribution methodsFor: 'rights' stamp: 'NorbertHartl 7/2/2011 18:02'!
makePublic: aStructure

	aStructure securityDecoration owner: self kernel users anyOne.
	aStructure securityDecoration otherPermissions: Set new.
	aStructure securityDecoration group: self kernel groups anyOne.
! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
menuPage
	^ menuWidget ifNil: 
		[ menuWidget := (PRPage named: 'menu')
			contents:
'- *Home>/*
- *Blog>/blog*
- *About>/about*';
			yourself ]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
metaEnvironmentPage
	^ metaEnvironmentPage ifNil: [
		metaEnvironmentPage := (PRPage named: 'metaenvironment')
		title: '_Meta Environment';
"		hideFromMenus: true;"
		contents: '{{{<div class="container metaenvironment">
	<div class="span-24 last metaheader">
		Meta page: }}}+/system/components/breadcrumb+{{{
	</div>
	<div class="span-24 last">
		}}}+/system/components/contents+{{{
	</div>
	<div class="span-24 last metafooter">
		<div class="span-10">}}}+/system/components/commands+{{{</div>
		<div class="span-10 last">}}}+/system/components/sitemap+{{{</div>
	</div>
</div>}}}';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
postTickerWidget
	^ postTickerWidget ifNil: [
		postTickerWidget := (PRComponent named: 'postticker')
		title: 'Post Ticker';
		componentClass: PBPostTicker;
		write: blog using: PBPostTicker descriptionBlog;
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
poweredPage
	^ poweredByPage ifNil: [poweredByPage := (PRPage named: 'poweredby')
		title: 'Powered By';
		contents: 
'Powered by *Pier>http://www.piercms.com*';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'creation' stamp: 'NorbertHartl 7/2/2011 18:16'!
register 
	WAAdmin register: PRAdminFramePierFrame asApplicationAt: 'pier-admin'.
	"PRPierFrame 
		registerAsApplication: 'pier-admin'
		kernel: self kernel"! !

!PRAdminDistribution methodsFor: 'creation' stamp: 'NorbertHartl 7/2/2011 18:08'!
root
	self rootPage
		addChild: self blog;
		addChild: (self aboutPage
				addChild: self syntaxPage;
				yourself);
		addChild: (self systemPage
			addChild: (self componentsPage
				addChild: self headerPage;
				addChild: self siteTitlePage;
				addChild: self footerPage;
				addChild: self menuPage;
				addChild: self childrenWidget;
				addChild: self breadcrumbWidget;
				addChild: self googleAnalyticsWidget;
				addChild: self sitemapPage;
				addChild: self viewsPage;
				addChild: self commandsPage;
				addChild: self loginCommandWidget;
				addChild: self contentsWidget;
				addChild: self stylesheetFile;
				addChild: self postTickerWidget;
				addChild: self blogArchiveWidget;
				addChild: self searchWidget;
				addChild: self poweredPage;
				addChild: self loggedInUserPage;
				addChild: self documentWidget;
				yourself);
			addChild: self systemManagementPage;
			addChild: (self templatesPage
				addChild: self environmentPage;
				addChild: self blogEnvironmentPage;
				addChild: self mainEnvironmentPage;
				addChild: self metaEnvironmentPage;
				yourself
			);
			yourself
		).
	self rootPage localEnvironment: self mainEnvironmentPage.
	self blog localEnvironment: self blogEnvironmentPage.
	self aboutPage localEnvironment: self environmentPage.
	self environmentPage localEnvironment: self metaEnvironmentPage.
	self mainEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self metaEnvironmentPage localEnvironment: self metaEnvironmentPage.
	self systemManagementPage localEnvironment: self metaEnvironmentPage.
	self rootPage localStyleSheet: self stylesheetFile.
	self rootPage enumerator
		with;
		all;
		do: 
			[ :each | 
			each securityDecoration owner: self kernel users anyOne.
			each securityDecoration group: self kernel groups anyOne ].
	self makePrivate: self systemPage.
	self makePrivate: self environmentPage.
	self makePrivate: self blogEnvironmentPage.
	self makePrivate: self mainEnvironmentPage.
	self makePrivate: self metaEnvironmentPage.
	self makePrivate: self sitemapPage.
	self makePrivate: self viewsPage.
	self makePrivate: self commandsPage.
	self makePrivate: self systemManagementPage.
	self makePrivate: self loggedInUserPage.
	^ self rootPage! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:09'!
rootPage
	^ rootPage ifNil: [
		rootPage := (PRPage named: 'pier-admin')
		title: 'Welcome to Pier Admin!!';
		yourself.

		rootPage 
		contents:
'This is pier admin. Resistance is futile. Prepare to be visited'.
		rootPage]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
searchWidget
	^ searchWidget ifNil: [
		searchWidget := (PRComponent named: 'search')
			componentClass: PRSearchWidget;
			write: ( PRStructure withAllConcreteClasses reject: [:each | each = PRPage or: [each = PBPost]] ) using: PRAjaxSearchWidget descriptionFilter ;
			yourself
	].! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
siteTitlePage
	^ siteTitlePage ifNil: [
		siteTitlePage := (PRPage named: 'sitetitle')
		title: 'Site Title';
		contents: '!!*Your Pier>/*';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
sitemapPage
	^ sitemapPage ifNil: [
		sitemapPage := (PRPage named: 'sitemap')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRTreeWidget;
				yourself);
		contents:
'Sitemap
+widget+'
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:14'!
stylesheetFile
	^ stylesheetFile ifNil: [
		stylesheetFile := (PRFile named: 'defaultCss')
		filename: 'style.css';
		mimetype: 'text/css';
		contents: 
'/* HEADER */
.icon a {outline: none; background: white;}
.search input.text {
	border: 1px solid white;
	color: black;}
.search input.text:focus {
	border: 1px solid #ff6633;
	color: black;}
.search input {
	color: #ff6633;
	font-size: 1em;
	outline: none;
	width: 98%;
	border: 0;
	margin-top: 0.1em;
	padding: 0.3em;
	padding-top: 0;
	background: 0;}
.search ul {
	margin: 0;
	padding: 0;
	background: white;
	list-style-type: none;
	border: 1px solid #ff6633;
	border-top: 0;}
.search li.selected a {color: #fff;}
.search li.selected {
	background-color: #ff6633;
	color: white;}
.search li {
	margin: 0;
	display: block;
	padding: 0.2em;
	cursor: pointer;
	list-style-type: none;}
.menu ul {
	margin: 0;
	margin-top: 0.2em;
	padding-bottom: 0.2em;
	list-style-type: none;}
.menu ul li {
	display: inline;
	margin: 0;
	margin-right: 1.5em;
	list-style-type: none;}
.menu li a {
	padding-left: 0.3em;
	padding-right: 0.3em;
	padding-top: 0.5em;
	padding-bottom: 0.3em;}


/*BLOG*/
div.post {margin-bottom: 4.5em;}
div.comment {margin-bottom: 3em;}
.meta {font-size: 80%; color: #aaa;}
.leavecomment {margin-top: 4.5em; margin-bottom: 4.5em;}
.comments {margin-top: 4.5em;}


/* NAVIGATION */
.sidebar ul {
	margin-top: 0;
	margin-left: 0;
	list-style-type: none;}
.sidebar ul ul {
	margin-bottom: 0;
	margin-left: 1.5em;}
.sidebar ul li {
	margin-top: 1.5em;}
.sidebar ul li a {
	padding-left: 0.3em;
	padding-right: 0.3em;
	padding-top: 0.3em;
	padding-bottom: 0.3em;}
.sidebar p,
.sidebar h1, .sidebar h2, .sidebar h3,
.sidebar .postticker .timestamp,
.sidebar .postticker .summary {padding-left: 0.3em;}
.sidebar .active,
.menu li a.active {
	color: white;
	background: #ff6633;}


/*MAIN BODY*/
.mainbody {
	padding-top: 4em;
	padding-bottom: 15em;}
.postticker ul {
	font-size: 80%;
	color: #aaa;
	list-style: none;
	margin-left: 0;}
.postticker ul li {
	margin-bottom: 1.5em;}
.postticker .timestamp {color: #aaa; font-size: 80%;}
.postticker .subscribe,
.postticker .timestamp .time,
.postticker .timestamp .author {display: none;}
.postticker a.post {color: #aaa;}


/* FOOTER */
.footer {
	color: #aaa;
	font-size: 80%;
	text-align: left;}
.footer a { color: #aaa;}
.footer ul {list-style: none; margin-left: 0em;}
.footer ul ul {margin-left: 1.5em;}
.footer .commands ul, .footer .views ul {display: inline;}
.footer .commands ul li, .footer .views ul li {display: inline; padding-right: 1em;}


/* META */
.metaenvironment h1.heading {display: none;}
.metaheader {background: #C3D9FF; font-size: 200%}
.metaheader ul {display: inline; margin: 0;}
.metaheader li {list-style: none; display: inline; margin: 0;}
.metaheader li:after {content: "/"}
.metaenvironment.container {border: 1px solid #C3D9FF; margin-top: 0;}
.metafooter {background: #C3D9FF;}
.metafooter li {list-style: none;}


/*DEFAULT*/
body {margin-top: 0;}
h1, h2, h3, h4, h5, h6 { margin: 0; font-weight: inherit; font-size: 100%; line-height: inherit; }
h1.heading { font-size: 2em; margin-bottom: 1.5em; }
h1 { font-size: 1.5em; line-height: 1; margin-bottom: 1em; }
.maincontents {font-size: 1.5em;}
h2 { font-size: 1.2em; height: 1.25em; line-height: 1.25; margin-bottom: 1.25em; }
h3 { font-size: 1em; font-weight: bold; margin-bottom: 1.5em; }
h4 { font-size: 1em; font-weight: bold; }
h5 { font-size: 1em; }
textarea {width: 100%;}
input.text, input.password {width: 200px;}
input[type="button"], input[type="submit"], input[type="reset"], input[type="file"], button { margin-left: 0.5em;} 


/* PIER */
.broken { color: red; font-weight: bold;}
.protected { color: #aaa; }
a {color: #ff6633;}
a:hover {
	color: white;
	background: #ff6633; }
a:hover.nobackground {background: white;}
a.view, a.command {color: gray;}
a {text-decoration: none;}
a.environment:after {content: "*";}
.right {text-align: right;}
.left {text-align: left;}
.center {text-align: center;}
.float {float: right;}
.nobullets ul {list-style: none; margin-left: 0;}
.nobullets ul li {list-style: none; margin-left: 0;}
tr th {background: #eee; font-weight: normal;}
label {font-weight: normal;}
tr.group th {background: white; font-size: 1em; font-weight: bold; margin-top: 1.5em; }
td.required:after {color: #ff6633; content: "*"; margin-left: 0.5em;}

#admin {
	float: left;
}';
		yourself]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
syntaxPage
	^ syntaxPage ifNil: [
		syntaxPage := PRKernel defaultInfoSyntax].! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
systemManagementPage
	^ systemManagementPage ifNil: [
		systemManagementPage := (PRPage named: 'management')
		title: 'Management';
		addChild: ((PRComponent named: 'users')
				componentClass: PUUsersWidget;
				yourself);
		addChild: ((PRComponent named: 'groups')
				componentClass: PUGroupsWidget;
				yourself);
		addChild: ((PRComponent named: 'persistency')
				componentClass: PRPersistencySettings;
				yourself);
		addChild: ((PRComponent named: 'kernel')
				componentClass: PRKernelSettings;
				yourself);
		addChild: ((PRComponent named: 'file')
				componentClass: PRFileSettings;
				yourself);
		contents: '!!Users
+users+

!!User Group
+groups+

!!Persistency
+persistency+

!!Kernel Settings
+kernel+

!!File Settings
+file+';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
systemPage
	^ systemPage ifNil: [
		systemPage := (PRPage named: 'system')
		contents: '*value:children|link*';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
templatesPage
	^ templatesPage ifNil: [
		templatesPage := (PRPage named: 'templates')
		contents: '*value:children|link*';
		yourself
	]! !

!PRAdminDistribution methodsFor: 'structures' stamp: 'NorbertHartl 7/2/2011 18:02'!
viewsPage
	^ viewsPage ifNil: [
		viewsPage := (PRPage named: 'views')
		addChild: ((PRComponent named: 'widget')
				componentClass: PRViewsWidget;
				yourself);
		contents: 'Views: +widget+'
	]! !

WAComponent subclass: #PRAdminFrame
	instanceVariableNames: 'selectedKernel context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin'!

!PRAdminFrame methodsFor: 'as yet unclassified' stamp: 'NickAger 7/3/2011 10:15'!
context
	self halt.^ context ifNil: [ context := PRContext kernel: self kernel ]! !

!PRAdminFrame methodsFor: 'as yet unclassified' stamp: 'NickAger 7/2/2011 13:58'!
context: aPierContext
	context := aPierContext! !

!PRAdminFrame methodsFor: 'rendering' stamp: 'NickAger 7/2/2011 13:01'!
forPierContext:  aPierContext updateRoot: anHtmlRoot
	PRBlueprintLibrary default updateRoot: anHtmlRoot.
	PRJavaScriptSupport default updateRoot: anHtmlRoot.
	
	self updateStyleSheets: anHtmlRoot 
	
! !

!PRAdminFrame methodsFor: 'as yet unclassified' stamp: 'NickAger 7/2/2011 14:10'!
initialRequest: aRequest
	| structure following |
	super initialRequest: aRequest.
	self session 
		addFilter: (PRContextFilter on: self)! !

!PRAdminFrame methodsFor: 'accessing' stamp: 'NickAger 7/3/2011 10:15'!
kernel
	^ self kernel ! !

!PRAdminFrame methodsFor: 'rendering' stamp: 'NickAger 7/2/2011 14:31'!
renderContentOn: html
	html script: 'if(window !!= top) { top.location = window.location }'.
	self renderPierKernelsOn: html.
	self renderSelectedKernelOn: html! !

!PRAdminFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 10:15'!
renderPierKernelsOn: html
	html form with: [
		html select
			beSubmitOnChange;
			list: PRKernel instances;
			on: #kernel of: self ]! !

!PRAdminFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 10:15'!
renderSelectedKernelOn: html
	self kernel isNil ifTrue: [ ^ self ].
	
	PRCurrentContextHolder use: self during: [
				html rendererInstance
					start: self structure environment
					in: self on: html].

"	html iframe
		rootBlock: [ :anHtmlRoot | self forPierContext: self context updateRoot: anHtmlRoot ];
		style: 'width: 800px; height: 800px';
		contents: [
			PRCurrentContextHolder use: self during: [
				html rendererInstance
					start: self structure environment
					in: self on: html	] ]"
	
	! !

!PRAdminFrame methodsFor: 'accessing' stamp: 'NickAger 7/2/2011 12:20'!
selectedKernel
	^ selectedKernel ifNil: [ selectedKernel := PRKernel instances any ]! !

!PRAdminFrame methodsFor: 'accessing' stamp: 'NickAger 7/2/2011 14:41'!
selectedKernel: anObject
	self halt.
	context := nil.
	selectedKernel := anObject.
! !

!PRAdminFrame methodsFor: 'as yet unclassified' stamp: 'NickAger 7/2/2011 12:40'!
structure
	^ self context structure ! !

!PRAdminFrame methodsFor: 'as yet unclassified' stamp: 'NickAger 7/2/2011 12:41'!
updateStyleSheets: aHtmlRoot
	self structure styleSheets do: [ :structure |
		structure file isEmpty ifFalse: [
			aHtmlRoot stylesheet 
				url: structure file url ] ]! !

PRPierFrame subclass: #PRAdminFramePierFrame
	instanceVariableNames: 'selectedKernel kernel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Admin'!

!PRAdminFramePierFrame methodsFor: 'as yet unclassified' stamp: 'NickAger 7/3/2011 10:31'!
contextViews
	^ self context views select: [ :each | each isListed ]! !

!PRAdminFramePierFrame methodsFor: 'accessing' stamp: 'NickAger 7/3/2011 11:03'!
emptyEnvironment
	^ (PRPage named: 'empty')
		contents: '+contents+';
		addChild: ((PRComponent named: 'contents') componentClass: PRContentsWidget);
		yourself! !

!PRAdminFramePierFrame methodsFor: 'accessing' stamp: 'NickAger 7/3/2011 11:06'!
environment
	^ self isShowingDefaultView
		ifTrue: [ super environment ]
		ifFalse: [ self emptyEnvironment ]! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/2/2011 16:20'!
forPierContext:  aPierContext updateRoot: anHtmlRoot
	PRBlueprintLibrary default updateRoot: anHtmlRoot.
	PRJavaScriptSupport default updateRoot: anHtmlRoot.
	
	self updateStyleSheets: anHtmlRoot 
	
! !

!PRAdminFramePierFrame methodsFor: 'as yet unclassified' stamp: 'NickAger 7/3/2011 11:05'!
isShowingDefaultView
	^ self context command asComponent isKindOf: PRDefaultView! !

!PRAdminFramePierFrame methodsFor: 'accessing' stamp: 'NickAger 7/3/2011 10:17'!
kernel
	^ kernel ifNil: [ kernel := PRKernel instances any ]! !

!PRAdminFramePierFrame methodsFor: 'accessing' stamp: 'NickAger 7/3/2011 10:16'!
kernel: anObject
	context := nil.
	kernel := anObject.
! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 10:41'!
renderBrowserNodeForStructure: aStructure on: html
	html listItem: [ 
		html anchor
			goto: (self context structure: aStructure);
			class: 'menuItem page';
			class: 'active' if: self context structure = aStructure; 
			with: aStructure title.
		html unorderedList: [
			aStructure enumerator do: [ :eachStructure | 
				self renderBrowserNodeForStructure: eachStructure on: html ] ] ]! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 10:41'!
renderBrowserOn: html
	html div
		class: 'block';
		id: 'browser';
		with: [ 
			html heading
				level: 2;
				with: 'Browser'.
				
			html unorderedList
				class: 'view';
				with: [ 
					self renderBrowserNodeForStructure: self kernel root on: html.
									html
										listItem: [ 
											(html anchor)
												url: '';
												class: 'system menuItem';
												title: 'System';
												with: 'System'.
											html
												unorderedList: [ 
													(html listItem)
														class: 'templates';
														with: [ 
																	(html anchor)
																		url: '';
																		class: 'templates menuItem';
																		title: 'Blog';
																		with: 'Templates' ].
													(html listItem)
														class: 'components';
														with: [ 
																	(html anchor)
																		url: '';
																		class: 'components menuItem';
																		title: 'About Pier';
																		with: 'Components' ].
													(html listItem)
														class: 'Management';
														with: [ 
																	(html anchor)
																		url: '';
																		class: 'management menuItem';
																		title: 'System';
																		with: 'Management' ] ] ] ].
					(html anchor)
						class: 'add';
						url: '';
						with: 'add...' ]! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 10:11'!
renderCommandsOn: html
	^ (html div)
		class: 'block';
		id: 'commands';
		with: [ 
					(html div)
						class: 'breadCrumb';
						with: 'home > blog'.
					(html heading)
						level: 2;
						with: 'Blog'.
					(html anchor)
						url: '';
						class: 'edit button';
						with: 'Edit page'.
					(html anchor)
						url: '';
						class: 'button';
						with: 'Move page'.
					(html anchor)
						url: '';
						class: 'button';
						with: 'Page settings'.
					(html anchor)
						url: '';
						class: 'button';
						with: 'Remove page' ]! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 10:09'!
renderContentOn: html
	self renderSidebarOn: html.
	self renderMainPaneOn: html
! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 10:12'!
renderHeaderOn: html
	(html div)
		class: 'block';
		id: 'header';
		with: [ 
			html div
				class: 'pierLogo';
				with: ''.
			html div
				class: 'sitenamer';
				with: [ self renderPierKernelsOn: html ].
			html anchor
				url: '';
				class: 'logout';
				title: 'Logout (l)';
				accessKey: 'l';
				with: 'Logout' ]! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 11:17'!
renderMainPaneOn: html

	html div
		class: 'main';
		with: [
			self kernel isNil ifFalse: [
				self renderTabsOn: html.
				html div
					id: #content;
					with: [
						self renderTabContentOn: html ] ] ]! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 10:16'!
renderPierKernelsOn: html
	html form with: [
		html select
			beSubmitOnChange;
			labels: [ :kernel | kernel name ];
			list: PRKernel instances;
			on: #kernel of: self ]! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 10:38'!
renderSidebarOn: html
	(html div)
		id: 'sidebar';
		with: [ 
			self renderHeaderOn: html.
			self renderBrowserOn: html.
			self renderCommandsOn: html ]! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 11:14'!
renderTabContentOn: html
	self isShowingDefaultView
		ifTrue: [
			html script: 'if(window !!= top) { top.location = window.location }'.
			html iframe
				rootBlock: [ :anHtmlRoot | self forPierContext: self context updateRoot: anHtmlRoot ];
				contents: [ self renderViewOn: html ]]
		ifFalse: [
			html div: [
				self renderViewOn: html ] ]! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 10:42'!
renderTabForView: aViewClass on: html
	html listItem: [
		html anchor
			goto: (self context view: aViewClass);
			with: aViewClass label ]! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 10:30'!
renderTabsOn: html
	html div
		id: #tabs;
		with: [
			html unorderedList: [
				self contextViews do: [ :eachView |
					self renderTabForView: eachView on: html ] ] ]! !

!PRAdminFramePierFrame methodsFor: 'rendering' stamp: 'NickAger 7/3/2011 11:10'!
renderViewOn: html
	^ PRCurrentContextHolder use: self during: [
			html rendererInstance
				start: self environment
				in: self on: html	]
	
	! !

!PRAdminFramePierFrame methodsFor: 'as yet unclassified' stamp: 'NickAger 7/3/2011 09:07'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	anHtmlRoot stylesheet url: '/templatefiles/pier.css'.
	"anHtmlRoot stylesheet url: '/templatefiles/screen.css'."
"	anHtmlRoot stylesheet url: '/templatefiles/development.css'."
	
! !
